from ubiquity import misc, plugin, validation
import os
import inspect
import socket

NAME = 'lliurexFlash'
AFTER = 'console_setup'
BEFORE = 'usersetup'
WEIGHT = 14

class PageGtk(plugin.PluginUI):
	plugin_title = 'lliurex/Flash'

	def __init__(self, controller, *args, **kwargs):
		from gi.repository import Gio, Gtk
		self.resolver = Gio.Resolver.get_default()
		self.controller = controller
		builder = Gtk.Builder()
		self.controller.add_builder(builder)
		builder.add_from_file(os.path.join(os.environ['UBIQUITY_GLADE'], 'UbiLliureXFlash.ui'))
		builder.connect_signals(self)
		self.page = builder.get_object('UbiLliureXFlash')
		
		self.installFlash = builder.get_object('label_installflash')
		self.installFlash.set_active(True)
		self.plugin_widgets = self.page
		
		self.skip = False
		
	def plugin_skip_page(self):
		# Set from the command line with --wireless
		ip_success=""
		internet= False
	
		try:
			ip_success = socket.gethostbyname("lliurex.net")
			print ("LliureX is reachable : " + ip_success)
			internet = True
		except Exception as e:
			print ("LliureX is unreachable:  "+ str(e))
	
		try:
			ip_success = socket.gethostbyname("server")
			print ("Server is reachable : " + ip_success)
			internet = True
		except Exception as e:
			print ("Server is unreachable:  "+ str(e))
	
		if internet:
			return False
		else:
			return True
	
		

class Page(plugin.Plugin):

	@misc.raise_privileges
	def ok_handler(self):
		list_packages = []
		
		# Using lliurex custom file instead of apt-installed. Ubiquity uses cdrom repository only when using apt-installed list
		list_file="/var/lib/ubiquity/lliurex-extra-packages"
		if self.ui.installFlash.get_active():
			os.system("mkdir -p /var/lib/ubiquity/")
			f = open(list_file,"a")
			f.write("adobe-flashplugin\n")
			f.close()
			
			# enable partner repositories
			self.preseed_bool('apt-setup/partner', True)
			
		else:
			if os.path.exists(list_file):
				f = open(list_file,"r")
				lines = f.readlines()
				f.close()
				f = open(list_file,"w")
				for line in lines:
					if line!="adobe-flashplugin"+"\n":
						f.write(line)
				f.close()
			
		plugin.Plugin.ok_handler(self)

